C
C     GSX-80 DRIVER for Postcript file
C     Copyright (C) 2014 by Udo Munk
C     Copyright (C) 2020 by Martin Hepperle
C

C234567890123456789012345678901234567890123456789012345678901234567890123456789
C----vv----------------------------------------------------------------v-------
      SUBROUTINE DDPS(CONTRL,INTIN,PTSIN,INTOUT,PTSOUT)
      INTEGER CONTRL(1),INTIN(1),PTSIN(1),INTOUT(1),PTSOUT(1)
C
C     VARIABLES
C
      INTEGER I,J,K,PAGE
      INTEGER OPCODE,INMODE
      LOGICAL PFLAG,OFLAG
      INTEGER PMSC,CANG,CHGT,LNTP,LNWD,MKTP,FILSTY
      INTEGER LINCOL,TXTCOL,FILCOL,PMKCOL
      INTEGER XY(2)
      INTEGER XLO,YLO,XHI,YHI
      INTEGER*1 LINE(10),CRLF(2)
      INTEGER CLAMP
      EXTERNAL CLAMP
C
C     DATA
C
C     PRINT FLAG FOR DRIVER COPYRIGHT AND VERSION TEXT
      DATA PFLAG /.FALSE./
C     WORKSTATION OPEN FLAG
      DATA OFLAG /.FALSE./
      DATA CRLF /13,10/
C
C     INITIALIZATION
C
      CONTRL(3) = 0
      CONTRL(5) = 0
      OPCODE = CONTRL(1)

C     DONT DRAW ON CLOSED WOKSTATION
      IF ((OFLAG  .NE. .TRUE.) .AND.
     1    (OPCODE .NE. 1) ) RETURN

C
C     DISPATCH ON OPCODE
C
      GOTO(1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     1     2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     2     3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     3     4100,4200,4300),OPCODE
      RETURN

C
C     OPCODE OPEN WORKSTATION
C
1100  IF (PFLAG .NE. .FALSE.) GOTO 1110
      CALL PSPRTV
      PFLAG = .TRUE.

1110  CONTRL(3) = 6
      CONTRL(5) = 45
      LNTP = CLAMP(INTIN(2),1,6)
      MKTP = CLAMP(INTIN(4),1,6)
      CHGT = 327
      CANG = 0
      PMSC = 2*327
      LNWD = 32
      FILSTY = 1
      LINCOL = CLAMP(INTIN(3),0,9)
      PMKCOL = CLAMP(INTIN(5),0,9)
      TXTCOL = CLAMP(INTIN(7),0,9)
      FILCOL = CLAMP(INTIN(10),0,9)

      INTOUT(1) = 23170
      INTOUT(2) = 32766
      INTOUT(3) = 0
C     mapping to DIN A4
      INTOUT(4) = 9
      INTOUT(5) = 9
      INTOUT(6) = 0
      INTOUT(7) = 6
      INTOUT(8) = 1
      INTOUT(9) = 6
      INTOUT(10) = 1
      INTOUT(11) = 1
      INTOUT(12) = 1
      INTOUT(13) = 0
C     # of predefined colors 1...10
      INTOUT(14) = 10
      INTOUT(15) = 0
      INTOUT(16) = -1
      INTOUT(17) = -1
      INTOUT(18) = -1
      INTOUT(19) = -1
      INTOUT(20) = -1
      INTOUT(21) = -1
      INTOUT(22) = -1
      INTOUT(23) = -1
      INTOUT(24) = -1
      INTOUT(25) = -1
      INTOUT(26) = -1
      INTOUT(27) = -1
      INTOUT(28) = -1
      INTOUT(29) = -1
      INTOUT(30) = -1
      INTOUT(31) = -1
      INTOUT(32) = -1
      INTOUT(33) = -1
      INTOUT(34) = -1
      INTOUT(35) = -1
      INTOUT(36) = 0
      INTOUT(37) = 1
      INTOUT(38) = 1
      INTOUT(39) = 0
      INTOUT(40) = 2
      INTOUT(41) = 0
      INTOUT(42) = 0
      INTOUT(43) = 0
      INTOUT(44) = 0
      INTOUT(45) = 0
      PTSOUT(1) = 0
C     min char height 1%
      PTSOUT(2) = 327
      PTSOUT(3) = 0
C     max char height 50%
      PTSOUT(4) = 16384
C     min line width 0.1%
      PTSOUT(5) = 32
      PTSOUT(6) = 0
C     max line width 25%
      PTSOUT(7) = 8192
      PTSOUT(8) = 0
      PTSOUT(9) = 0
C     min marker size 1%
      PTSOUT(10) = 327
      PTSOUT(11) = 0
C     max marker size 25%
      PTSOUT(12) = 8192
      OFLAG = .TRUE.
      PAGE = 0

      CALL PSOPEN
C     add page number
      GOTO 1300
C      RETURN

C
C     OPCODE CLOSE WORKSTATION
C
1200  CONTINUE
      CALL PSCRLF('x',1)
      CALL PSCRLF('%%Trailer',9)
      CALL PSSTR('%%Pages: ',9)
      CALL OUTNUM(PAGE)
      CALL PSSTR(CRLF,2)
      CALL PSCLOS
      OFLAG = .FALSE.
      RETURN

C
C     OPCODE CLEAR WORKSTATION
C
C     clear grapics
1300  IF ( PAGE .EQ. 0 ) GOTO 1305
      CALL PSCRLF('x',1)
1305  CALL PSSTR('%%Page: ',8)
      PAGE = PAGE+1
      CALL OUTNUM(PAGE)
      CALL PSOUT(' ')
      CALL OUTNUM(PAGE)
      CALL PSSTR(CRLF,2)
      CALL PSCRLF('p',1)
      RETURN

C
C     OPCODE UPDATE WORKSTATION
C
1400  CONTINUE
      RETURN
C
C     OPCODE ESCAPE
C
1500  OPCODE = CONTRL(6)
C     DISPATCH ON FUNCTION
      GOTO(1501,1502,1503,1504,1505,1506,1507,1508,1509,1510,
     1     1511,1512,1513,1514),OPCODE
      RETURN
C     INQUIRE ADDRESSABLE CHARACTER CELLS
1501  INTOUT(1) = 24
      INTOUT(2) = 80
      RETURN

C     ENTER GRAPHICS MODE
1502  CONTINUE
      RETURN

C     EXIT GRAPHICS MODE
1503  CONTINUE
      RETURN

C     CURSOR UP     Ctrl+A
1504  CONTINUE
      RETURN
C     CURSOR DOWN   Ctrl+B
1505  CONTINUE
      RETURN
C     CURSOR RIGHT  Ctrl+C
1506  CONTINUE
      RETURN
C     CURSOR LEFT   Ctrl+D
1507  CONTINUE
      RETURN
C     HOME CURSOR
1508  CONTINUE
      RETURN
C     ERASE TO END OF SCREEN
1509  CONTINUE
      RETURN
C     ERASE TO END OF LINE
1510  CONTINUE
      RETURN

C     DIRECT CURSOR ADDRESS
1511  CONTINUE
      I = CLAMP(INTIN(1),1,24)
      J = CLAMP(INTIN(2),1,80)
      RETURN

C     OUTPUT CURSOR ADDRESSABLE TEXT
1512  CONTINUE
      RETURN

C     REVERSE VIDEO ON
1513  CONTINUE
      RETURN

C     REVERSE VIDEO OFF
1514  CONTINUE
      RETURN

C
C     OPCODE POLYLINE
C
1600  CONTINUE
      J = CONTRL(2)
      K = 1
      CALL PSSTR('n ',2)
      CALL XYPAIR(PTSIN(K),PTSIN(K+1))
      CALL PSSTR('m ',2)
      K = K + 2
      DO 1601 I=2,J
        CALL XYPAIR(PTSIN(K),PTSIN(K+1))
        CALL PSSTR('l ',2)
        K = K + 2
1601  CONTINUE
      CALL PSCRLF('s',1)
      RETURN

C
C     OPCODE POLYMARKER
C
1700  CONTINUE
      K = CONTRL(2)
      J = 1
      DO 1701 I=1,K
        XY(1) = PTSIN(J)
        XY(2) = PTSIN(J+1)
        CALL MPLOT(XY,MKTP,PMSC)
        CALL PSSTR(CRLF,2)
        J = J + 2
1701  CONTINUE
      RETURN

C
C     OPCODE TEXT
C
1800  CONTINUE
      CALL PSSTR('(',1)
      CALL GSSTR(INTIN,CONTRL(4))
      CALL PSSTR(') ',2)
      CALL OUTNUM(CANG)
      CALL PSSTR(' ',1)
      CALL XYPAIR(PTSIN(1),PTSIN(2))
      CALL PSCRLF('a',1)
      RETURN

C
C     OPCODE FILLED AREA
C
1900  CONTINUE
      J = CONTRL(2)
      CALL PSSTR('n ',2)
      K = 1
      CALL XYPAIR(PTSIN(K),PTSIN(K+1))
      CALL PSSTR('m ',2)
      K = K+2
      DO 1901 I=2,J
        CALL XYPAIR(PTSIN(K),PTSIN(K+1))
        CALL PSSTR('l ',2)
        K = K + 2
1901  CONTINUE

      IF ( FILSTY .GT. 0 ) GOTO 1902
      CALL PSCRLF('s',1)
      GOTO 1910
1902  CONTINUE

      CALL OUTNUM(FILCOL)
      CALL PSCRLF(' sf',3)
1910  RETURN

C
C     OPCODE CELL ARRAY
C
2000  CONTINUE
      XLO = PTSIN(1)
      XHI = PTSIN(2)
      XHI = PTSIN(3)
      YHI = PTSIN(4)
      RETURN

C
C     OPCODE GENERALZED DRAWING PRIMITIVE
C
2100  RETURN

C
C     OPCODE SET CHARACTER HEIGHT
C
2200  CONTINUE
      CHGT = CLAMP(PTSIN(2),327,16384)
C     enlarge to fit character height
      I = CHGT + CHGT/4
      CALL OUTNUM(I)
      CALL PSCRLF(' f',2)

      CONTRL(3) = 2
C     avoid overflow
      PTSOUT(1) = CHGT/5*4
      PTSOUT(2) = CHGT
      PTSOUT(3) = CHGT/5*4
      PTSOUT(4) = CHGT/5*7
      RETURN

C
C     OPCODE SET CHARACTER ANGLE   [0...3600]
C
2300  CONTINUE
      CANG = INTIN(1)
      INTOUT(1) = CANG
      RETURN

C
C     OPCODE SET COLOR REPRESENTATION
C
2400  CONTINUE
      RETURN

C
C     OPCODE SET POLYLINE LINETYPE
C
2500  LNTP = CLAMP(INTIN(1),1,6)
      INTOUT(1) = LNTP
      CALL PSOUT('d')
      CALL OUTNUM(LNTP)
      CALL PSOUT(' ')
      RETURN

C
C     OPCODE SET POLYLINE WIDTH
C
2600  LNWD = CLAMP(INTIN(1),32,8192)
      CALL OUTNUM(LNWD)
      CALL PSSTR(' w ',3)
      CONTRL(3) = 1
      PTSOUT(1) = LNWD
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE SET POLYLINE COLOR INDEX
C
2700  LINCOL = CLAMP(INTIN(1),0,9)
      INTOUT(1) = LINCOL
      RETURN

C
C     OPCODE SET POLYMARKER TYPE
C
2800  MKTP = CLAMP(INTIN(1),1,6)
      INTOUT(1) = MKTP
      RETURN

C
C     OPCODE SET POLYMARKER SCALE
C
2900  PMSC = CLAMP(PTSIN(2),327,8192)
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = PMSC
      RETURN

C
C     OPCODE SET POLYMARKER COLOR INDEX
C
3000  PMKCOL = CLAMP(INTIN(1),0,9)
      INTOUT(1) = PMKCOL
      RETURN

C
C     OPCODE SET TEXT FONT
C
3100  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT COLOR INDEX
C
3200  TXTCOL = CLAMP(INTIN(1),0,9)
      INTOUT(1) = TXTCOL
      RETURN

C
C     OPCODE SET FILL INTERIOR STYLE
C     0 = outline, 1,2,3 = solid
3300  FILSTY = CLAMP(INTIN(1),0,3)
      INTOUT(1) = FILSTY
      RETURN

C
C     OPCODE SET FILL STYLE INDEX
C
3400  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL COLOR INDEX
C     FILCOL 0...9
3500  FILCOL = CLAMP(INTIN(1),0,9)
      INTOUT(1) = FILCOL
      RETURN

C
C     OPCODE INQUIRE COLOR REPRESENTATION
C
3600  INTOUT(1) = INTIN(1)
      INTOUT(2) = 0
      INTOUT(3) = 0
      INTOUT(4) = 0
      RETURN

C
C     OPCODE INQUIRE CELL ARRAY
C
3700  CONTRL(8) = 0
      CONTRL(9) = 0
      CONTRL(10) = 1
      RETURN

C
C     OPCODE INPUT LOCATOR
C
3800  CONTINUE
      CONTRL(5) = 1
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE INPUT VALUATOR
C
3900  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT CHOICE
C
4000  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT STRING
C
4100  RETURN

C
C     OPCODE SET WRITING MODE
C
4200  INTOUT(1) = 2
      RETURN

C
C     OPCODE SET INPUT MODE
C
4300  INMODE = INTIN(2)
      INTOUT(1) = INMODE
      RETURN
      END

      SUBROUTINE PSCRLF(S,N)
      INTEGER*1 S(255)
      INTEGER N
      INTEGER*1 CRLF(2)
      DATA CRLF /13,10/

      CALL PSSTR(S,N)
      CALL PSSTR(CRLF,2)

      RETURN
      END
C
C     OUTPUT XY COORDINATES AS "X Y "
C
      SUBROUTINE XYPAIR(X,Y)
      INTEGER X,Y

      CALL OUTNUM(X)
      CALL PSOUT(' ')
      CALL OUTNUM(Y)
      CALL PSOUT(' ')

      RETURN
      END

C
C     DRAW A MARKER AT THE CURRENT LOCATION
C
      SUBROUTINE MPLOT(INTIN,TYPE,PMSC)
      INTEGER INTIN(2),TYPE,PMSC

      INTEGER X1,X2,Y1,Y2
      INTEGER X3,X4,Y3,Y4
      INTEGER RXY1,RXY2

C     bounding box
      X1 = INTIN(1) - PMSC/2
      X2 = X1 + PMSC
      Y1 = INTIN(2) - PMSC/2
      Y2 = Y1 + PMSC

C     test bounding box
      IF (MIN0(X1,Y1).LT.0 .OR. MAX0(X2,Y2).GT.32766) RETURN

C     for 'x' and '*' approx. PMSC*COS(PI/4)
      RXY1 = PMSC/3 + PMSC/50
      X3 = INTIN(1) - RXY1
      X4 = INTIN(1) + RXY1
      Y3 = INTIN(2) - RXY1
      Y4 = INTIN(2) + RXY1

      CALL PSSTR('n ',2)

      IF (TYPE.EQ.1 .OR. TYPE.EQ.4 .OR. TYPE.EQ.6) GOTO 5040
      IF (TYPE.EQ.3.OR.TYPE.EQ.5) GOTO 5020
C     TYPE .EQ. 2 or invalid
      GOTO 5035

C     3,5: 'x'
5020  CONTINUE
      CALL XYPAIR(X3,Y3)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X4,Y4)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X3,Y4)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X4,Y3)
      CALL PSSTR('l ',2)
5030  IF (TYPE.EQ.3) GOTO 5035
      GOTO 5060

C     2,3: '+'
5035  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL XYPAIR(X3,Y1)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X3,Y2)
      CALL PSSTR('l ',2)
      RXY1 = X1 + PMSC/2
      CALL XYPAIR(X1,Y3)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X2,Y3)
      CALL PSSTR('l ',2)
      GOTO 5060

C     1,4,6: dot = small x
5040  CONTINUE
      X3 = X1 + PMSC/2 - 30
      Y3 = Y1 + PMSC/2 - 30
      X4 = X3 + 60
      Y4 = Y3 + 60
      CALL XYPAIR(X3,Y3)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X4,Y4)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X3,Y4)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X4,Y3)
      CALL PSSTR('l ',2)
      IF (TYPE.EQ.1) GOTO 5060
      IF (TYPE.EQ.6) GOTO 5050
C     4: fall through

C     4: square with dot
5045  CONTINUE
      CALL XYPAIR(X1,Y1)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X2,Y1)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X2,Y2)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X1,Y2)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X1,Y1)
      CALL PSSTR('l ',2)
      GOTO 5060

C     6: diamond with dot
5050  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL XYPAIR(X1,Y3)
      CALL PSSTR('m ',2)
      CALL XYPAIR(X3,Y2)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X2,Y3)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X3,Y1)
      CALL PSSTR('l ',2)
      CALL XYPAIR(X1,Y3)
      CALL PSSTR('l ',2)

5060  CALL PSSTR('s ',2)
      RETURN
      END

C
C     OUTPUT 16-BIT DECIMAL NUMBER IN ASCII
C
      SUBROUTINE OUTNUM(IINUM)
      INTEGER*2 IINUM
C     local
      INTEGER*1 C,IDX
      INTEGER*2 IDIV,INUM

      INUM = IINUM

1     IDX = 0
      C = 0
      IDIV = 0
      IF (INUM .EQ. 0) GOTO 5

      IDIV = 10000

2     CONTINUE
      C = 0

3     CONTINUE
      IF (INUM .LT. IDIV) GOTO 4
      C = C+1
      INUM=INUM-IDIV
      GOTO 3

4     CONTINUE

C     suppress leading zeroes
      IF (IDX .EQ. 0 .AND. C .EQ. 0) GOTO 6

5     IDX = IDX+1
      C = C + '0'
      CALL PSOUT(C)

C     next digit
6     IDIV = IDIV/10

      IF (IDIV .GT. 0) GOTO 2

      RETURN
      END

C
C     Limit I to the range LO...HI
C
      INTEGER FUNCTION CLAMP ( I, LO, HI )
      INTEGER I,LO,HI

      IF (I .LT. LO) GOTO 100
      IF (I .GT. HI) GOTO 200

      CLAMP = I
      RETURN

100   CLAMP = LO
      RETURN

200   CLAMP = HI
      RETURN
      END
